package tools;

import cartago.*;

public class Counter extends Artifact {
    private int max;
    
    void init(int max) {
        defineObsProperty("count", 0);
        this.max = max;
    }
	
    @OPERATION
    void inc() {
        int v;
        ObsProperty prop = getObsProperty("count");
        v=prop.intValue();
        if (v<max) {
            prop.updateValue(v+1);
            signal("tick",v+1);
        } else {
            failed("inc failed", "inc_failed", "max_value_reached", max);
        }
    }
}

